Index: doc/Doxyfile.in
===================================================================
--- doc/Doxyfile.in	(revision 1053)
+++ doc/Doxyfile.in	(revision 1074)
@@ -100,6 +100,5 @@
                          "@abs_top_srcdir@/tools" \
                          "@abs_top_srcdir@/test/test_tools.h" \
-                         "@abs_top_builddir@/doc/mainpage.dox" \
-                         "@abs_top_builddir@/doc/references.dox"
+                         "@abs_top_builddir@/doc/mainpage.dox"
 INPUT_ENCODING         = UTF-8
 FILE_PATTERNS          = *.h \
Index: doc/lgf.dox
===================================================================
--- doc/lgf.dox	(revision 1024)
+++ doc/lgf.dox	(revision 1074)
@@ -65,5 +65,5 @@
 
 The \e LGF files can also contain bipartite graphs, in this case a
-\c @red_nodes and a \c @blue_nodes sections describe the node set of the
+\c \@red_nodes and a \c \@blue_nodes sections describe the node set of the
 graph. If a map is in both of these sections, then it can be used as a
 regular node map.
Index: lemon/bellman_ford.h
===================================================================
--- lemon/bellman_ford.h	(revision 880)
+++ lemon/bellman_ford.h	(revision 1074)
@@ -201,9 +201,10 @@
     /// The type of the paths.
     typedef PredMapPath<Digraph, PredMap> Path;
-    ///\brief The \ref BellmanFordDefaultOperationTraits
+    ///\brief The \ref lemon::BellmanFordDefaultOperationTraits
     /// "operation traits class" of the algorithm.
     typedef typename TR::OperationTraits OperationTraits;
 
-    ///The \ref BellmanFordDefaultTraits "traits class" of the algorithm.
+    ///\brief The \ref lemon::BellmanFordDefaultTraits "traits class"
+    ///of the algorithm.
     typedef TR Traits;
 
Index: lemon/bfs.h
===================================================================
--- lemon/bfs.h	(revision 976)
+++ lemon/bfs.h	(revision 1074)
@@ -153,5 +153,5 @@
     typedef PredMapPath<Digraph, PredMap> Path;
 
-    ///The \ref BfsDefaultTraits "traits class" of the algorithm.
+    ///The \ref lemon::BfsDefaultTraits "traits class" of the algorithm.
     typedef TR Traits;
 
Index: lemon/capacity_scaling.h
===================================================================
--- lemon/capacity_scaling.h	(revision 1071)
+++ lemon/capacity_scaling.h	(revision 1074)
@@ -119,5 +119,6 @@
     typedef typename TR::Heap Heap;
 
-    /// The \ref CapacityScalingDefaultTraits "traits class" of the algorithm
+    /// \brief The \ref lemon::CapacityScalingDefaultTraits "traits class"
+    /// of the algorithm
     typedef TR Traits;
 
Index: lemon/christofides_tsp.h
===================================================================
--- lemon/christofides_tsp.h	(revision 1037)
+++ lemon/christofides_tsp.h	(revision 1074)
@@ -232,5 +232,5 @@
       ///
       /// This function copies the found tour as a list of arcs/edges into
-      /// the given \ref concept::Path "path structure".
+      /// the given \ref lemon::concepts::Path "path structure".
       ///
       /// \pre run() must be called before using this function.
Index: lemon/circulation.h
===================================================================
--- lemon/circulation.h	(revision 998)
+++ lemon/circulation.h	(revision 1074)
@@ -196,5 +196,6 @@
   public:
 
-    ///The \ref CirculationDefaultTraits "traits class" of the algorithm.
+    /// \brief The \ref lemon::CirculationDefaultTraits "traits class"
+    /// of the algorithm.
     typedef TR Traits;
     ///The type of the digraph the algorithm runs on.
Index: lemon/cost_scaling.h
===================================================================
--- lemon/cost_scaling.h	(revision 1071)
+++ lemon/cost_scaling.h	(revision 1074)
@@ -153,5 +153,6 @@
     typedef typename TR::LargeCost LargeCost;
 
-    /// The \ref CostScalingDefaultTraits "traits class" of the algorithm
+    /// \brief The \ref lemon::CostScalingDefaultTraits "traits class"
+    /// of the algorithm
     typedef TR Traits;
 
Index: lemon/cplex.h
===================================================================
--- lemon/cplex.h	(revision 1063)
+++ lemon/cplex.h	(revision 1074)
@@ -179,5 +179,5 @@
     /// to a file in the given format.
     /// Trying to write in an unsupported format will trigger
-    /// \ref UnsupportedFormatError.
+    /// \ref lemon::LpBase::UnsupportedFormatError "UnsupportedFormatError".
     /// \param file The file path
     /// \param format The output file format.
Index: lemon/dfs.h
===================================================================
--- lemon/dfs.h	(revision 1000)
+++ lemon/dfs.h	(revision 1074)
@@ -153,5 +153,5 @@
     typedef PredMapPath<Digraph, PredMap> Path;
 
-    ///The \ref DfsDefaultTraits "traits class" of the algorithm.
+    ///The \ref lemon::DfsDefaultTraits "traits class" of the algorithm.
     typedef TR Traits;
 
Index: lemon/dijkstra.h
===================================================================
--- lemon/dijkstra.h	(revision 877)
+++ lemon/dijkstra.h	(revision 1074)
@@ -228,9 +228,9 @@
     ///The heap type used by the algorithm.
     typedef typename TR::Heap Heap;
-    ///\brief The \ref DijkstraDefaultOperationTraits "operation traits class"
-    ///of the algorithm.
+    /// \brief The \ref lemon::DijkstraDefaultOperationTraits
+    /// "operation traits class" of the algorithm.
     typedef typename TR::OperationTraits OperationTraits;
 
-    ///The \ref DijkstraDefaultTraits "traits class" of the algorithm.
+    ///The \ref lemon::DijkstraDefaultTraits "traits class" of the algorithm.
     typedef TR Traits;
 
Index: lemon/edmonds_karp.h
===================================================================
--- lemon/edmonds_karp.h	(revision 1061)
+++ lemon/edmonds_karp.h	(revision 1074)
@@ -81,6 +81,6 @@
   /// This class provides an implementation of the \e Edmonds-Karp \e
   /// algorithm producing a \ref max_flow "flow of maximum value" in a
-  /// digraph \ref clrs01algorithms, \ref amo93networkflows,
-  /// \ref edmondskarp72theoretical.
+  /// digraph \cite clrs01algorithms, \cite amo93networkflows,
+  /// \cite edmondskarp72theoretical.
   /// The Edmonds-Karp algorithm is slower than the Preflow
   /// algorithm, but it has an advantage of the step-by-step execution
@@ -113,5 +113,6 @@
   public:
 
-    /// The \ref EdmondsKarpDefaultTraits "traits class" of the algorithm.
+    /// \brief The \ref lemon::EdmondsKarpDefaultTraits "traits class"
+    /// of the algorithm.
     typedef TR Traits;
     /// The type of the digraph the algorithm runs on.
Index: lemon/fractional_matching.h
===================================================================
--- lemon/fractional_matching.h	(revision 877)
+++ lemon/fractional_matching.h	(revision 1074)
@@ -124,6 +124,6 @@
   public:
 
-    /// \brief The \ref MaxFractionalMatchingDefaultTraits "traits
-    /// class" of the algorithm.
+    /// \brief The \ref lemon::MaxFractionalMatchingDefaultTraits
+    /// "traits class" of the algorithm.
     typedef TR Traits;
     /// The type of the graph the algorithm runs on.
Index: lemon/glpk.h
===================================================================
--- lemon/glpk.h	(revision 1063)
+++ lemon/glpk.h	(revision 1074)
@@ -153,5 +153,5 @@
     /// to a file in the given format.
     /// Trying to write in an unsupported format will trigger
-    /// \ref UnsupportedFormatError.
+    /// \ref LpBase::UnsupportedFormatError.
     /// \param file The file path
     /// \param format The output file format.
Index: lemon/greedy_tsp.h
===================================================================
--- lemon/greedy_tsp.h	(revision 1037)
+++ lemon/greedy_tsp.h	(revision 1074)
@@ -229,5 +229,5 @@
       ///
       /// This function copies the found tour as a list of arcs/edges into
-      /// the given \ref concept::Path "path structure".
+      /// the given \ref lemon::concepts::Path "path structure".
       ///
       /// \pre run() must be called before using this function.
Index: lemon/hartmann_orlin_mmc.h
===================================================================
--- lemon/hartmann_orlin_mmc.h	(revision 1053)
+++ lemon/hartmann_orlin_mmc.h	(revision 1074)
@@ -144,9 +144,12 @@
     ///
     /// The path type of the found cycles.
-    /// Using the \ref HartmannOrlinMmcDefaultTraits "default traits class",
+    /// Using the \ref lemon::HartmannOrlinMmcDefaultTraits
+    /// "default traits class",
     /// it is \ref lemon::Path "Path<Digraph>".
     typedef typename TR::Path Path;
 
-    /// The \ref HartmannOrlinMmcDefaultTraits "traits class" of the algorithm
+    /// \brief The
+    /// \ref lemon::HartmannOrlinMmcDefaultTraits "traits class"
+    /// of the algorithm
     typedef TR Traits;
 
Index: lemon/howard_mmc.h
===================================================================
--- lemon/howard_mmc.h	(revision 1053)
+++ lemon/howard_mmc.h	(revision 1074)
@@ -143,9 +143,9 @@
     ///
     /// The path type of the found cycles.
-    /// Using the \ref HowardMmcDefaultTraits "default traits class",
+    /// Using the \ref lemon::HowardMmcDefaultTraits "default traits class",
     /// it is \ref lemon::Path "Path<Digraph>".
     typedef typename TR::Path Path;
 
-    /// The \ref HowardMmcDefaultTraits "traits class" of the algorithm
+    /// The \ref lemon::HowardMmcDefaultTraits "traits class" of the algorithm
     typedef TR Traits;
 
Index: lemon/insertion_tsp.h
===================================================================
--- lemon/insertion_tsp.h	(revision 1037)
+++ lemon/insertion_tsp.h	(revision 1074)
@@ -226,5 +226,5 @@
       ///
       /// This function copies the found tour as a list of arcs/edges into
-      /// the given \ref concept::Path "path structure".
+      /// the given \ref lemon::concepts::Path "path structure".
       ///
       /// \pre run() must be called before using this function.
Index: lemon/karp_mmc.h
===================================================================
--- lemon/karp_mmc.h	(revision 1053)
+++ lemon/karp_mmc.h	(revision 1074)
@@ -141,9 +141,9 @@
     ///
     /// The path type of the found cycles.
-    /// Using the \ref KarpMmcDefaultTraits "default traits class",
+    /// Using the \ref lemon::KarpMmcDefaultTraits "default traits class",
     /// it is \ref lemon::Path "Path<Digraph>".
     typedef typename TR::Path Path;
 
-    /// The \ref KarpMmcDefaultTraits "traits class" of the algorithm
+    /// The \ref lemon::KarpMmcDefaultTraits "traits class" of the algorithm
     typedef TR Traits;
 
Index: lemon/lgf_reader.h
===================================================================
--- lemon/lgf_reader.h	(revision 1030)
+++ lemon/lgf_reader.h	(revision 1074)
@@ -1231,7 +1231,8 @@
   /// \ingroup lemon_io
   ///
-  /// \brief Return a \ref DigraphReader class
-  ///
-  /// This function just returns a \ref DigraphReader class.
+  /// \brief Return a \ref lemon::DigraphReader "DigraphReader" class
+  ///
+  /// This function just returns a \ref lemon::DigraphReader
+  /// "DigraphReader" class.
   ///
   /// With this function a digraph can be read from an
@@ -1253,7 +1254,8 @@
   ///\endcode
   ///
-  /// For a complete documentation, please see the \ref DigraphReader
+  /// For a complete documentation, please see the
+  /// \ref lemon::DigraphReader "DigraphReader"
   /// class documentation.
-  /// \warning Don't forget to put the \ref DigraphReader::run() "run()"
+  /// \warning Don't forget to put the \ref lemon::DigraphReader::run() "run()"
   /// to the end of the parameter list.
   /// \relates DigraphReader
@@ -2109,7 +2111,7 @@
   /// \ingroup lemon_io
   ///
-  /// \brief Return a \ref GraphReader class
-  ///
-  /// This function just returns a \ref GraphReader class.
+  /// \brief Return a \ref lemon::GraphReader "GraphReader" class
+  ///
+  /// This function just returns a \ref lemon::GraphReader "GraphReader" class.
   ///
   /// With this function a graph can be read from an
@@ -2127,7 +2129,8 @@
   ///\endcode
   ///
-  /// For a complete documentation, please see the \ref GraphReader
+  /// For a complete documentation, please see the
+  /// \ref lemon::GraphReader "GraphReader"
   /// class documentation.
-  /// \warning Don't forget to put the \ref GraphReader::run() "run()"
+  /// \warning Don't forget to put the \ref lemon::GraphReader::run() "run()"
   /// to the end of the parameter list.
   /// \relates GraphReader
@@ -3175,7 +3178,8 @@
   /// \ingroup lemon_io
   ///
-  /// \brief Return a \ref BpGraphReader class
-  ///
-  /// This function just returns a \ref BpGraphReader class.
+  /// \brief Return a \ref lemon::BpGraphReader "BpGraphReader" class
+  ///
+  /// This function just returns a \ref lemon::BpGraphReader
+  /// "BpGraphReader" class.
   ///
   /// With this function a graph can be read from an
@@ -3193,7 +3197,8 @@
   ///\endcode
   ///
-  /// For a complete documentation, please see the \ref BpGraphReader
+  /// For a complete documentation, please see the
+  /// \ref lemon::BpGraphReader "BpGraphReader"
   /// class documentation.
-  /// \warning Don't forget to put the \ref BpGraphReader::run() "run()"
+  /// \warning Don't forget to put the \ref lemon::BpGraphReader::run() "run()"
   /// to the end of the parameter list.
   /// \relates BpGraphReader
Index: lemon/lgf_writer.h
===================================================================
--- lemon/lgf_writer.h	(revision 1030)
+++ lemon/lgf_writer.h	(revision 1074)
@@ -945,7 +945,8 @@
   /// \ingroup lemon_io
   ///
-  /// \brief Return a \ref DigraphWriter class
-  ///
-  /// This function just returns a \ref DigraphWriter class.
+  /// \brief Return a \ref lemon::DigraphWriter "DigraphWriter" class
+  ///
+  /// This function just returns a \ref lemon::DigraphWriter
+  /// "DigraphWriter" class.
   ///
   /// With this function a digraph can be write to a file or output
@@ -968,7 +969,8 @@
   ///\endcode
   ///
-  /// For a complete documentation, please see the \ref DigraphWriter
+  /// For a complete documentation, please see the
+  /// \ref lemon::DigraphWriter "DigraphWriter"
   /// class documentation.
-  /// \warning Don't forget to put the \ref DigraphWriter::run() "run()"
+  /// \warning Don't forget to put the \ref lemon::DigraphWriter::run() "run()"
   /// to the end of the parameter list.
   /// \relates DigraphWriter
@@ -1584,7 +1586,7 @@
   /// \ingroup lemon_io
   ///
-  /// \brief Return a \ref GraphWriter class
-  ///
-  /// This function just returns a \ref GraphWriter class.
+  /// \brief Return a \ref lemon::GraphWriter "GraphWriter" class
+  ///
+  /// This function just returns a \ref lemon::GraphWriter "GraphWriter" class.
   ///
   /// With this function a graph can be write to a file or output
@@ -1603,7 +1605,8 @@
   ///\endcode
   ///
-  /// For a complete documentation, please see the \ref GraphWriter
+  /// For a complete documentation, please see the
+  /// \ref lemon::GraphWriter "GraphWriter"
   /// class documentation.
-  /// \warning Don't forget to put the \ref GraphWriter::run() "run()"
+  /// \warning Don't forget to put the \ref lemon::GraphWriter::run() "run()"
   /// to the end of the parameter list.
   /// \relates GraphWriter
@@ -2402,7 +2405,8 @@
   /// \ingroup lemon_io
   ///
-  /// \brief Return a \ref BpGraphWriter class
-  ///
-  /// This function just returns a \ref BpGraphWriter class.
+  /// \brief Return a \ref lemon::BpGraphWriter "BpGraphWriter" class
+  ///
+  /// This function just returns a \ref lemon::BpGraphWriter
+  /// "BpGraphWriter" class.
   ///
   /// With this function a bipartite graph can be write to a file or output
@@ -2421,7 +2425,8 @@
   ///\endcode
   ///
-  /// For a complete documentation, please see the \ref BpGraphWriter
+  /// For a complete documentation, please see the
+  /// \ref lemon::BpGraphWriter "BpGraphWriter"
   /// class documentation.
-  /// \warning Don't forget to put the \ref BpGraphWriter::run() "run()"
+  /// \warning Don't forget to put the \ref lemon::BpGraphWriter::run() "run()"
   /// to the end of the parameter list.
   /// \relates BpGraphWriter
Index: lemon/lp_base.h
===================================================================
--- lemon/lp_base.h	(revision 1063)
+++ lemon/lp_base.h	(revision 1074)
@@ -1008,5 +1008,5 @@
   public:
 
-    ///\e
+    ///\e \ 
     class UnsupportedFormatError : public Exception
     {
Index: lemon/min_cost_arborescence.h
===================================================================
--- lemon/min_cost_arborescence.h	(revision 877)
+++ lemon/min_cost_arborescence.h	(revision 1074)
@@ -129,5 +129,5 @@
   public:
 
-    /// \brief The \ref MinCostArborescenceDefaultTraits "traits class"
+    /// \brief The \ref lemon::MinCostArborescenceDefaultTraits "traits class"
     /// of the algorithm.
     typedef TR Traits;
Index: lemon/nearest_neighbor_tsp.h
===================================================================
--- lemon/nearest_neighbor_tsp.h	(revision 1037)
+++ lemon/nearest_neighbor_tsp.h	(revision 1074)
@@ -216,5 +216,5 @@
       ///
       /// This function copies the found tour as a list of arcs/edges into
-      /// the given \ref concept::Path "path structure".
+      /// the given \ref lemon::concepts::Path "path structure".
       ///
       /// \pre run() must be called before using this function.
Index: lemon/opt2_tsp.h
===================================================================
--- lemon/opt2_tsp.h	(revision 1037)
+++ lemon/opt2_tsp.h	(revision 1074)
@@ -253,5 +253,5 @@
       ///
       /// This function copies the found tour as a list of arcs/edges into
-      /// the given \ref concept::Path "path structure".
+      /// the given \ref lemon::concepts::Path "path structure".
       ///
       /// \pre run() must be called before using this function.
Index: lemon/preflow.h
===================================================================
--- lemon/preflow.h	(revision 1053)
+++ lemon/preflow.h	(revision 1074)
@@ -135,5 +135,5 @@
   public:
 
-    ///The \ref PreflowDefaultTraits "traits class" of the algorithm.
+    ///The \ref lemon::PreflowDefaultTraits "traits class" of the algorithm.
     typedef TR Traits;
     ///The type of the digraph the algorithm runs on.
Index: lemon/suurballe.h
===================================================================
--- lemon/suurballe.h	(revision 877)
+++ lemon/suurballe.h	(revision 1074)
@@ -138,5 +138,5 @@
     typedef typename TR::Heap Heap;
 
-    /// The \ref SuurballeDefaultTraits "traits class" of the algorithm.
+    /// The \ref lemon::SuurballeDefaultTraits "traits class" of the algorithm.
     typedef TR Traits;
 